Index: /extensions/UserCollections/include/ws_functions.inc.php
===================================================================
--- /extensions/UserCollections/include/ws_functions.inc.php	(revision 25677)
+++ /extensions/UserCollections/include/ws_functions.inc.php	(revision 25678)
@@ -6,5 +6,5 @@
   $service = &$arr[0];
   global $conf;
-  
+
   $service->addMethod(
     'pwg.collections.create',
@@ -17,5 +17,5 @@
     'Create a new User Collection.'
     );
-    
+
   $service->addMethod(
     'pwg.collections.delete',
@@ -26,5 +26,5 @@
     'Delete a User Collection.'
     );
-    
+
   $service->addMethod(
     'pwg.collections.getList',
@@ -42,5 +42,5 @@
     'Returns a list of collections.'
     );
-    
+
   $service->addMethod(
     'pwg.collections.addImages',
@@ -52,5 +52,5 @@
     'Add images to a collection.'
     );
-    
+
   $service->addMethod(
     'pwg.collections.removeImages',
@@ -62,5 +62,5 @@
     'Remove images from a collection.'
     );
-    
+
   $service->addMethod(
     'pwg.collections.getImages',
@@ -74,5 +74,5 @@
     'Returns elements for the corresponding  collection.'
     );
-    
+
   $service->addMethod(
     'pwg.collections.getSerialized',
@@ -88,5 +88,5 @@
     'Returns a serialized version of the collection in CSV.<br>The return type is plain/text whatever you select as response format.'
     );
-    
+
   $service->addMethod(
     'pwg.collections.getInfo',
@@ -105,11 +105,11 @@
 {
   global $conf, $user;
-  
-  // check status
-  if (is_a_guest())
-  {
-    return new PwgError(403, 'Forbidden');
-  }
-  
+
+  // check status
+  if (is_a_guest())
+  {
+    return new PwgError(403, 'Forbidden');
+  }
+
   // check name
   if (empty($params['name']))
@@ -117,5 +117,5 @@
     return new PwgError(WS_ERR_MISSING_PARAM, 'Empty collection name');
   }
-  
+
   // check user id
   if (!empty($params['user_id']))
@@ -135,7 +135,7 @@
     $params['user_id'] = $user['id'];
   }
-  
+
   $collection = new UserCollection('new', $params['name'], $params['comment'], $params['user_id']);
-  
+
   return array_change_key_case($collection->getCollectionInfo(), CASE_LOWER);
 }
@@ -147,15 +147,15 @@
 {
   global $user;
-  
-  // check status
-  if (is_a_guest())
-  {
-    return new PwgError(403, 'Forbidden');
-  }
-  
-  try {
-    $collection = new UserCollection($params['col_id']);
-    $collection->checkUser();
-    
+
+  // check status
+  if (is_a_guest())
+  {
+    return new PwgError(403, 'Forbidden');
+  }
+
+  try {
+    $collection = new UserCollection($params['col_id']);
+    $collection->checkUser();
+
     $collection->delete();
   }
@@ -172,11 +172,11 @@
 {
   global $user, $conf;
-  
-  // check status
-  if (is_a_guest())
-  {
-    return new PwgError(403, 'Forbidden');
-  }
-  
+
+  // check status
+  if (is_a_guest())
+  {
+    return new PwgError(403, 'Forbidden');
+  }
+
   // check user_id
   if (!empty($params['user_id']))
@@ -196,5 +196,5 @@
     $params['user_id'] = $user['id'];
   }
-  
+
   // search
   $where_clauses = array('1=1');
@@ -207,9 +207,9 @@
     $where_clauses[] = 'name LIKE("%'.pwg_db_real_escape_string($params['name']).'%")';
   }
-  
+
   $order_by = !empty($params['order']) ? $params['order'] : 'username ASC, name ASC';
-  
+
   $query = '
-SELECT 
+SELECT
     c.*,
     u.'.$conf['user_fields']['username'].' AS username
@@ -223,5 +223,5 @@
 ;';
   $sets = hash_from_query($query, 'id');
-  
+
   $data = array();
   foreach ($sets as $row)
@@ -238,5 +238,5 @@
       );
   }
-  
+
   return array(
     'paging' => new PwgNamedStruct(array(
@@ -250,5 +250,5 @@
       )
     );
-  
+
   return $ret;
 }
@@ -260,17 +260,17 @@
 {
   global $conf, $user;
-  
-  // check status
-  if (is_a_guest())
-  {
-    return new PwgError(403, 'Forbidden');
-  }
-
-  try {
-    $collection = new UserCollection($params['col_id']);
-    $collection->checkUser();
-    
+
+  // check status
+  if (is_a_guest())
+  {
+    return new PwgError(403, 'Forbidden');
+  }
+
+  try {
+    $collection = new UserCollection($params['col_id']);
+    $collection->checkUser();
+
     $collection->addImages($params['image_ids']);
-    
+
     return array('nb_images' => $collection->getParam('nb_images'));
   }
@@ -287,17 +287,17 @@
 {
   global $conf, $user;
-  
-  // check status
-  if (is_a_guest())
-  {
-    return new PwgError(403, 'Forbidden');
-  }
-  
-  try {
-    $collection = new UserCollection($params['col_id']);
-    $collection->checkUser();
-    
+
+  // check status
+  if (is_a_guest())
+  {
+    return new PwgError(403, 'Forbidden');
+  }
+
+  try {
+    $collection = new UserCollection($params['col_id']);
+    $collection->checkUser();
+
     $collection->removeImages($params['image_ids']);
-    
+
     return array('nb_images' => $collection->getParam('nb_images'));
   }
@@ -314,18 +314,18 @@
 {
   global $conf, $user;
-  
-  // check status
-  if (is_a_guest())
-  {
-    return new PwgError(403, 'Forbidden');
-  }
-
-  try {
-    $collection = new UserCollection($params['col_id']);
-    $collection->checkUser();
-    
+
+  // check status
+  if (is_a_guest())
+  {
+    return new PwgError(403, 'Forbidden');
+  }
+
+  try {
+    $collection = new UserCollection($params['col_id']);
+    $collection->checkUser();
+
     $image_ids = $collection->getImages();
     $images = array();
-    
+
     if (!empty($image_ids))
     {
@@ -343,5 +343,5 @@
 SELECT i.*
   FROM '.IMAGES_TABLE.' i
-  WHERE 
+  WHERE
     '. implode("\n AND ", $where_clauses).'
   GROUP BY i.id
@@ -366,9 +366,9 @@
         }
         $image = array_merge($image, ws_std_get_urls($row));
-        
+
         array_push($images, $image);
       }
     }
-    
+
     return array(
       'paging' => new PwgNamedStruct(array(
@@ -396,20 +396,20 @@
 {
   global $conf, $user;
-  
-  // check status
-  if (is_a_guest())
-  {
-    return new PwgError(403, 'Forbidden');
-  }
-
-  try {
-    $collection = new UserCollection($params['col_id']);
-    $collection->checkUser();
-    
+
+  // check status
+  if (is_a_guest())
+  {
+    return new PwgError(403, 'Forbidden');
+  }
+
+  try {
+    $collection = new UserCollection($params['col_id']);
+    $collection->checkUser();
+
     // change encoder to plain text
     include_once(USER_COLLEC_PATH.'include/plain_encoder.php');
     $encoder = new PwgPlainEncoder();
     $service->setEncoder('plain', $encoder);
-  
+
     return $collection->serialize($params['content']);
   }
@@ -426,15 +426,15 @@
 {
   global $conf, $user;
-  
-  // check status
-  if (is_a_guest())
-  {
-    return new PwgError(403, 'Forbidden');
-  }
-
-  try {
-    $collection = new UserCollection($params['col_id']);
-    $collection->checkUser();
-  
+
+  // check status
+  if (is_a_guest())
+  {
+    return new PwgError(403, 'Forbidden');
+  }
+
+  try {
+    $collection = new UserCollection($params['col_id']);
+    $collection->checkUser();
+
     return array_change_key_case($collection->getCollectionInfo(), CASE_LOWER);
   }
@@ -444,4 +444,2 @@
   }
 }
-
-?>
Index: /extensions/UserCollections/index.php
===================================================================
--- /extensions/UserCollections/index.php	(revision 25677)
+++ /extensions/UserCollections/index.php	(revision 25678)
@@ -1,26 +1,3 @@
 <?php
-// +-----------------------------------------------------------------------+
-// | Piwigo - a PHP based photo gallery                                    |
-// +-----------------------------------------------------------------------+
-// | Copyright(C) 2008-2012 Piwigo Team                  http://piwigo.org |
-// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
-// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
-// +-----------------------------------------------------------------------+
-// | This program is free software; you can redistribute it and/or modify  |
-// | it under the terms of the GNU General Public License as published by  |
-// | the Free Software Foundation                                          |
-// |                                                                       |
-// | This program is distributed in the hope that it will be useful, but   |
-// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
-// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
-// | General Public License for more details.                              |
-// |                                                                       |
-// | You should have received a copy of the GNU General Public License     |
-// | along with this program; if not, write to the Free Software           |
-// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
-// | USA.                                                                  |
-// +-----------------------------------------------------------------------+
-
-// Recursive call
 $url = '../';
 header( 'Request-URI: '.$url );
@@ -28,3 +5,2 @@
 header( 'Location: '.$url );
 exit();
-?>
Index: /extensions/UserCollections/language/en_UK/plugin.lang.php
===================================================================
--- /extensions/UserCollections/language/en_UK/plugin.lang.php	(revision 25677)
+++ /extensions/UserCollections/language/en_UK/plugin.lang.php	(revision 25678)
@@ -55,4 +55,5 @@
 $lang['Message (optional)'] = 'Message (optional)';
 $lang['Hello <b>%s</b>, %s sent you a photos collection from <a href="%s">%s</a>'] = 'Hello <b>%s</b>, %s sent you a photo collection from <a href="%s">%s</a>';
+$lang['Hello %s, %s sent you a photos collection from "%s"'] = 'Hello %s, %s sent you a photos collection from "%s"';
 $lang['Click here to view the complete collection'] = 'Click here to view the complete collection';
 $lang['Date added to collection, new &rarr; old'] = 'Date added to collection, new &rarr; old';
@@ -62,4 +63,10 @@
 $lang['Photos number, high &rarr; low'] = 'Photos number, high &rarr; low';
 $lang['Photos number, low &rarr; high'] = 'Photos number, low &rarr; high';
+$lang['Add'] = 'Add';
+$lang['Cancel'] = 'Cancel';
+$lang['Description'] = 'Description';
+$lang['jump to photo'] = 'jump to photo';
+$lang['Name'] = 'Name';
+$lang['Send'] = 'Send';
 
 ?>
Index: /extensions/UserCollections/language/fr_FR/plugin.lang.php
===================================================================
--- /extensions/UserCollections/language/fr_FR/plugin.lang.php	(revision 25677)
+++ /extensions/UserCollections/language/fr_FR/plugin.lang.php	(revision 25678)
@@ -55,4 +55,5 @@
 $lang['Message (optional)'] = 'Message (optionel)';
 $lang['Hello <b>%s</b>, %s sent you a photos collection from <a href="%s">%s</a>'] = 'Bonjour <b>%s</b>, %s vous a envoyé une collection de photos depuis <a href="%s">%s</a>';
+$lang['Hello %s, %s sent you a photos collection from "%s"'] = 'Bonjour %s, %s vous a envoyé une collection de photos depuis "%s"';
 $lang['Click here to view the complete collection'] = 'Cliquez ici pour voir la collection complète';
 $lang['Date added to collection, new &rarr; old'] = 'Date d\'ajout à la collection, récent &rarr; ancien';
@@ -62,4 +63,10 @@
 $lang['Photos number, high &rarr; low'] = 'Nombre de photos, élévé &rarr; faible';
 $lang['Photos number, low &rarr; high'] = 'Nombre de photos, faible &rarr; élévé';
+$lang['Add'] = 'Ajouter';
+$lang['Cancel'] = 'Annuler';
+$lang['Description'] = 'Description';
+$lang['jump to photo'] = 'Voir la photo';
+$lang['Name'] = 'Nom';
+$lang['Send'] = 'Envoyer';
 
 ?>
Index: /extensions/UserCollections/main.inc.php
===================================================================
--- /extensions/UserCollections/main.inc.php	(revision 25677)
+++ /extensions/UserCollections/main.inc.php	(revision 25678)
@@ -1,3 +1,3 @@
-<?php 
+<?php
 /*
 Plugin Name: User Collections
@@ -18,5 +18,5 @@
 global $conf, $prefixeTable;
 
-defined('USER_COLLEC_ID') or define('USER_COLLEC_ID', basename(dirname(__FILE__)));
+define('USER_COLLEC_ID',          basename(dirname(__FILE__)));
 define('USER_COLLEC_PATH',        PHPWG_PLUGINS_PATH . USER_COLLEC_ID . '/');
 define('COLLECTIONS_TABLE',       $prefixeTable.'collections');
@@ -43,5 +43,4 @@
   // thumbnails actions
   add_event_handler('loc_end_index_thumbnails', 'user_collections_thumbnails_list', EVENT_HANDLER_PRIORITY_NEUTRAL-10, 2);
-  add_event_handler('loc_end_index_thumbnails', 'uc_anti_lightbox', 41);
 
   // picture action
@@ -64,34 +63,12 @@
 function user_collections_init()
 {
-  global $pwg_loaded_plugins, $conf;
-  
-  if (
-    USER_COLLEC_VERSION == 'auto' or
-    $pwg_loaded_plugins[USER_COLLEC_ID]['version'] == 'auto' or
-    version_compare($pwg_loaded_plugins[USER_COLLEC_ID]['version'], USER_COLLEC_VERSION, '<')
-  )
-  {
-    include_once(USER_COLLEC_PATH . 'include/install.inc.php');
-    user_collections_install();
-    
-    if ( $pwg_loaded_plugins[USER_COLLEC_ID]['version'] != 'auto' and USER_COLLEC_VERSION != 'auto' )
-    {
-      $query = '
-UPDATE '. PLUGINS_TABLE .'
-SET version = "'. USER_COLLEC_VERSION .'"
-WHERE id = "'. USER_COLLEC_ID .'"';
-      pwg_query($query);
-      
-      $pwg_loaded_plugins[USER_COLLEC_ID]['version'] = USER_COLLEC_VERSION;
-      
-      if (defined('IN_ADMIN'))
-      {
-        $_SESSION['page_infos'][] = 'UserCollections updated to version '. USER_COLLEC_VERSION;
-      }
-    }
-  }
-  
+  global $conf;
+
+  include_once(USER_COLLEC_PATH . 'maintain.inc.php');
+  $maintain = new UserCollections_maintain(USER_COLLEC_ID);
+  $maintain->autoUpdate(USER_COLLEC_VERSION, 'install');
+
   load_language('plugin.lang', USER_COLLEC_PATH);
-  
+
   $conf['user_collections'] = unserialize($conf['user_collections']);
 }
@@ -100,12 +77,11 @@
  * admin plugins menu
  */
-function user_collections_admin_menu($menu) 
+function user_collections_admin_menu($menu)
 {
-  array_push($menu, array(
+  $menu[] = array(
     'NAME' => 'User Collections',
     'URL' => USER_COLLEC_ADMIN,
-  ));
+    );
+
   return $menu;
 }
-
-?>
Index: /extensions/UserCollections/maintain.inc.php
===================================================================
--- /extensions/UserCollections/maintain.inc.php	(revision 25677)
+++ /extensions/UserCollections/maintain.inc.php	(revision 25678)
@@ -2,33 +2,126 @@
 if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
 
-defined('USER_COLLEC_ID') or define('USER_COLLEC_ID', basename(dirname(__FILE__)));
-include_once(PHPWG_PLUGINS_PATH . USER_COLLEC_ID . '/include/install.inc.php');
+class UserCollections_maintain extends PluginMaintain
+{
+  private $installed = false;
 
-function plugin_install() 
-{
-  user_collections_install();
-  
-  define('user_collections_installed', true);
-}
+  function install($plugin_version, &$errors=array())
+  {
+    global $conf, $prefixeTable;
 
-function plugin_activate()
-{
-  if (!defined('user_collections_intalled'))
+    if (empty($conf['user_collections']))
+    {
+      $conf['user_collections'] = serialize(array(
+        'allow_mails' => true,
+        'allow_public' => true,
+        ));
+
+      conf_update_param('user_collections', $conf['user_collections']);
+    }
+
+    // create tables
+    $query = '
+CREATE TABLE IF NOT EXISTS `'.$prefixeTable.'collections` (
+  `id` mediumint(8) NOT NULL AUTO_INCREMENT,
+  `user_id` smallint(5) DEFAULT NULL,
+  `name` varchar(255) NOT NULL,
+  `date_creation` datetime NOT NULL,
+  `comment` text NULL,
+  `nb_images` mediumint(8) NOT NULL DEFAULT 0,
+  PRIMARY KEY (`id`)
+) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1
+;';
+    pwg_query($query);
+
+    $query = '
+CREATE TABLE IF NOT EXISTS `'.$prefixeTable.'collection_images` (
+  `col_id` mediumint(8) NOT NULL,
+  `image_id` mediumint(8) NOT NULL,
+  `add_date` datetime NULL,
+  UNIQUE KEY `UNIQUE` (`col_id`,`image_id`)
+) ENGINE=MyISAM DEFAULT CHARSET=utf8
+;';
+    pwg_query($query);
+
+    $query = '
+CREATE TABLE IF NOT EXISTS `'.$prefixeTable.'collection_shares` (
+  `id` mediumint(8) NOT NULL AUTO_INCREMENT,
+  `col_id` mediumint(8) NOT NULL,
+  `share_key` varchar(64) NOT NULL,
+  `params` text NULL,
+  `add_date` datetime NOT NULL,
+  PRIMARY KEY (`id`),
+  UNIQUE KEY `share_key` (`share_key`)
+) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1
+;';
+    pwg_query($query);
+
+
+    // version 2.0.0
+    $result = pwg_query('SHOW COLUMNS FROM `'.$prefixeTable.'collection_images` LIKE "add_date";');
+    if (!pwg_db_num_rows($result))
+    {
+      pwg_query('ALTER TABLE `'.$prefixeTable.'collection_images` ADD `add_date` datetime NULL;');
+    }
+
+    $result = pwg_query('SHOW COLUMNS FROM `'.$prefixeTable.'collections` LIKE "comment";');
+    if (!pwg_db_num_rows($result))
+    {
+      pwg_query('ALTER TABLE `'.$prefixeTable.'collections` ADD `comment` text NULL;');
+      pwg_query('ALTER TABLE `'.$prefixeTable.'collections` DROP `active`;');
+    }
+
+    // version 2.1.0
+    $result = pwg_query('SHOW COLUMNS FROM `'.$prefixeTable.'collections` LIKE "public";');
+    if (pwg_db_num_rows($result))
+    {
+      $now = date('Y-m-d H:i:s');
+
+      $query = '
+SELECT id, public_id
+  FROM `'.$prefixeTable.'collections`
+  WHERE public = 1
+;';
+      $result = pwg_query($query);
+
+      $inserts = array();
+      while ($row = pwg_db_fetch_assoc($result))
+      {
+        $inserts[] = array(
+          'col_id' => $row['id'],
+          'share_key' => $row['public_id'],
+          'params' => serialize(array('password'=>'','deadline'=>'')),
+          'add_date' => $now,
+          );
+      }
+
+      mass_inserts($prefixeTable.'collection_shares',
+        array('col_id','share_key','params','add_date'),
+        $inserts
+        );
+
+      pwg_query('ALTER TABLE `'.$prefixeTable.'collections` DROP `public`, DROP `public_id`;');
+    }
+  }
+
+  function activate($plugin_version, &$errors=array())
   {
-    user_collections_install();
+    if (!$this->installed)
+    {
+      $this->install($plugin_version, $errors);
+    }
+  }
+
+  function deactivate(){}
+
+  function uninstall()
+  {
+    global $prefixeTable;
+
+    conf_delete_param('user_collections');
+
+    pwg_query('DROP TABLE IF EXISTS `'.$prefixeTable.'collections`;');
+    pwg_query('DROP TABLE IF EXISTS `'.$prefixeTable.'collection_images`;');
+    pwg_query('DROP TABLE IF EXISTS `'.$prefixeTable.'collection_shares`;');
   }
 }
-
-function plugin_uninstall() 
-{
-  global $prefixeTable, $conf;
-  
-  pwg_query('DELETE FROM `'. CONFIG_TABLE .'` WHERE param = "user_collections";');
-  pwg_query('DROP TABLE IF EXISTS `'.$prefixeTable.'collections`;');
-  pwg_query('DROP TABLE IF EXISTS `'.$prefixeTable.'collection_images`;');
-  pwg_query('DROP TABLE IF EXISTS `'.$prefixeTable.'collection_shares`;');
-  
-  unset($conf['user_collections']);
-}
-
-?>
